/*hest massiivi elementide jagamine kahte massiivi*/
/*Tulemuste vljastamiseks on kasutatud funktsiooni*/

#include <stdio.h>

/*maksimaalne elementide arv massiivides*/
#define N 10

/*funktsioonide prototbid*/
void numbrid_ekraanile(int [], int);
void yhest_kaks (int [], int [], int [], int , int , int*, int*);

int main(void)
{
    /*massiiv, mis sisaldab inimeste vanuseid*/
    /*programmi kigus luuakse sellest kaks massiivi*/
    int vanused[N]={10,15,5,35,45,20,22,18,17,27};
    
    /*deklareerime loodavad massiivid*/
    int noored[N];
    int mittenoored[N];
    
    int i;                        /*tskliloendur*/
    int n_loendur=0, m_loendur=0; /*loendurid, millega mrame noorte ja mittenoorte arvu*/
    int taks=22;                  /*vanus, mille jrgi me inimesed kahte gruppi jagame*/
    
    /*prdume funktsiooni yhest_kaks poole                                  */
    /*mrame parameetrite vrtuseks: algmassiiv, kaks loodavat massiivi    */
    /*elementide arv algmassiivis; uute massiivide elementide arvu aadressid */
    /*(et funktsioon elementide aru vrtusi muuta saaks)                    */
    yhest_kaks(vanused, noored, mittenoored, taks, N, &n_loendur, &m_loendur);
    
    /*vljastame algandmed*/
    printf("Koik vanused on: ");
    numbrid_ekraanile(vanused, N);
    
    printf("Taks on: %d\n\n", taks);
       
    /*vljastame tulemused*/
    printf("%30s","Mittenoored vanused on: ");
    numbrid_ekraanile(mittenoored, m_loendur);
    
    printf("%30s","Noored vanused on: ");
    numbrid_ekraanile(noored, n_loendur);
    
    
    return 0;
}

/*funktsioon vektori vljastamiseks*/
/*parameetrid: vektor, elementide arv vektoris*/
void numbrid_ekraanile(int numbrid[], int arv)
{
    int i; /*lokaalne muutuja; tsklimuutuja*/ 
    
    for(i=0; i<arv; i++)
    {
             printf("%3d",numbrid[i]);
    }         
    /*reavahetus*/
    printf("\n");
} 

/*funktsioon hest massiivist kahe loomiseks                               */
/*parameetrid: algmassiiv NUMBRID, loodavad massiivid NUMBRID1 ja NUMBRID2 */
/*             piir - vrtus mille phjal massiivid kaheks jagatakse      */
/*             n - elementide arv algmassiivis                             */
/*             n1 ja n2 - elementide arv loodavates massiivides, viitparameetrid*/
void yhest_kaks (int numbrid[], int numbrid1[], int numbrid2[], int piir, int n, int *n1, int *n2)
{
     int i; /*tsklimuutuja; lokaalne muutuja*/
     
     for (i=0; i<n; i++)
     {        
         /*kui massiivis olev vrtus on viksem kui etteantud piir*/
         if(numbrid[i]<piir)
         {
            /*lisame esimesele massiivile elemendi*/
            numbrid1[*n1]=numbrid[i];
            (*n1)++;
            
         }
         else /*kui massiivis olev vrtus ei ole viksem kui etteantud piir*/
         {   
             /*lisame teisele massiivile elemendi*/
             numbrid2[*n2]=numbrid[i];                            
             (*n2)++;
         }
     }    
}             

                     
                     
                                
